package ru.ifmo.vizi.RadixSort;

import ru.ifmo.vizi.base.auto.*;
import java.util.Locale;

public final class RadixSort extends BaseAutoReverseAutomata {
    /**
      *  .
      */
    public final Data d = new Data();

    /**
      *   
      */
    public RadixSort(Locale locale) {
        super("ru.ifmo.vizi.RadixSort.Comments", locale); 
        init(new Main(), d); 
    }

    /**
      * .
      */
    public final class Data {
        /**
          *   .
          */
        public int[] a = new int[]{7834, 345, 55, 2343, 5466};

        /**
          *  .
          */
        public int[] res = new int[]{0, 0, 0, 0, 0};

        /**
          *  .
          */
        public int[] counter = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

        /**
          *  .
          */
        public RadixSortVisualizer visualizer = null;

        /**
          *     ( Main).
          */
        public int Main_i;

        /**
          *      ( Main).
          */
        public int Main_j;

        /**
          *      ( Main).
          */
        public int Main_digit;

        /**
          *       ( Main).
          */
        public int Main_v;

        /**
          *   10 ( Main).
          */
        public int Main_p;

        public String toString() {
            StringBuffer s = new StringBuffer();
            return s.toString();
        }
    }

    /**
      *      .
      */
    private final class Main extends BaseAutomata implements Automata {
        /**
          *   .
          */
        private final int START_STATE = 0;

        /**
          *   .
          */
        private final int END_STATE = 19;

        /**
          * .
          */
        public Main() {
            super( 
                "Main", 
                0, //    
                19, //    
                new String[]{ 
                    " ",  
                    "", 
                    "   ", 
                    "  ", 
                    "   ", 
                    "  ", 
                    " counter", 
                    " j", 
                    "     ", 
                    "    ", 
                    " ", 
                    " j", 
                    "   ", 
                    "   ", 
                    " ", 
                    " ", 
                    " j", 
                    "    ", 
                    " i", 
                    " " 
                }, new int[]{ 
                    Integer.MAX_VALUE, //  ,  
                    0, //  
                    -1, //     
                    -1, //    
                    -1, //     
                    -1, //    
                    0, //  counter 
                    -1, //  j 
                    -1, //       
                    -1, //      
                    0, //   
                    -1, //  j 
                    -1, //     
                    -1, //     
                    0, //   
                    0, //   
                    -1, //  j 
                    -1, //      
                    -1, //  i 
                    Integer.MAX_VALUE, //   
                } 
            ); 
        }

        /**
          *      .
          */
        protected void doStepForward(int level) {
            //    
            switch (state) {
                case START_STATE: { //  
                    state = 1; // 
                    break;
                }
                case 1: { // 
                    state = 2; //    
                    break;
                }
                case 2: { //    
                    stack.pushBoolean(false); 
                    state = 3; //   
                    break;
                }
                case 3: { //   
                    if (d.Main_i < 4) {
                        state = 4; //    
                    } else {
                        state = END_STATE; 
                    }
                    break;
                }
                case 4: { //    
                    stack.pushBoolean(false); 
                    state = 5; //   
                    break;
                }
                case 5: { //   
                    if (d.Main_j < d.a.length) {
                        state = 6; //  counter
                    } else {
                        state = 8; //      
                    }
                    break;
                }
                case 6: { //  counter
                    state = 7; //  j
                    break;
                }
                case 7: { //  j
                    stack.pushBoolean(true); 
                    state = 5; //   
                    break;
                }
                case 8: { //      
                    stack.pushBoolean(false); 
                    state = 9; //     
                    break;
                }
                case 9: { //     
                    if (d.Main_j < 10) {
                        state = 10; //  
                    } else {
                        state = 12; //    
                    }
                    break;
                }
                case 10: { //  
                    state = 11; //  j
                    break;
                }
                case 11: { //  j
                    stack.pushBoolean(true); 
                    state = 9; //     
                    break;
                }
                case 12: { //    
                    stack.pushBoolean(false); 
                    state = 13; //    
                    break;
                }
                case 13: { //    
                    if (d.Main_j < d.a.length) {
                        state = 14; //  
                    } else {
                        state = 17; //     
                    }
                    break;
                }
                case 14: { //  
                    state = 15; //  
                    break;
                }
                case 15: { //  
                    state = 16; //  j
                    break;
                }
                case 16: { //  j
                    stack.pushBoolean(true); 
                    state = 13; //    
                    break;
                }
                case 17: { //     
                    state = 18; //  i
                    break;
                }
                case 18: { //  i
                    stack.pushBoolean(true); 
                    state = 3; //   
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { // 
                    startSection();
                    storeField(d, "Main_i");
                    d.Main_i = 0;
                    break;
                }
                case 2: { //    
                    startSection();
                    storeField(d, "Main_i");
                    d.Main_i = 0;
                    storeField(d, "Main_p");
                    d.Main_p = 1;
                    break;
                }
                case 3: { //   
                    break;
                }
                case 4: { //    
                    startSection();
                    storeField(d, "counter");
                    d.counter = new int[10];
                    storeField(d, "res");
                    d.res = new int[d.a.length];
                    storeField(d, "Main_j");
                    d.Main_j = 0;
                    break;
                }
                case 5: { //   
                    break;
                }
                case 6: { //  counter
                    startSection();
                    storeField(d, "Main_digit");
                    d.Main_digit = d.a[d.Main_j] / d.Main_p % 10;
                    storeArray(d.counter, d.a[d.Main_j] / d.Main_p % 10);
                    d.counter[d.a[d.Main_j] / d.Main_p % 10] = d.counter[d.a[d.Main_j] / d.Main_p % 10] + 1;
                    break;
                }
                case 7: { //  j
                    startSection();
                    storeField(d, "Main_j");
                    d.Main_j = d.Main_j + 1;
                    break;
                }
                case 8: { //      
                    startSection();
                    storeField(d, "Main_j");
                    d.Main_j = 0;
                    storeField(d, "Main_v");
                    d.Main_v = 0;
                    break;
                }
                case 9: { //     
                    break;
                }
                case 10: { //  
                    startSection();
                    storeField(d, "Main_v");
                    d.Main_v = d.Main_v + d.counter[d.Main_j];
                    storeArray(d.counter, d.Main_j);
                    d.counter[d.Main_j] = d.Main_v - d.counter[d.Main_j];
                    break;
                }
                case 11: { //  j
                    startSection();
                    storeField(d, "Main_j");
                    d.Main_j = d.Main_j + 1;
                    break;
                }
                case 12: { //    
                    startSection();
                    storeField(d, "Main_j");
                    d.Main_j = 0;
                    break;
                }
                case 13: { //    
                    break;
                }
                case 14: { //  
                    startSection();
                    storeField(d, "Main_digit");
                    d.Main_digit = d.a[d.Main_j] / d.Main_p % 10;
                    storeArray(d.res, d.counter[d.Main_digit]);
                    d.res[d.counter[d.Main_digit]] = d.a[d.Main_j];
                    break;
                }
                case 15: { //  
                    startSection();
                    storeArray(d.counter, d.Main_digit);
                    d.counter[d.Main_digit] = d.counter[d.Main_digit] + 1;
                    break;
                }
                case 16: { //  j
                    startSection();
                    storeField(d, "Main_j");
                    d.Main_j = d.Main_j + 1;
                    break;
                }
                case 17: { //     
                    startSection();
                    storeField(d, "a");
                    d.a = d.res;
                    break;
                }
                case 18: { //  i
                    startSection();
                    storeField(d, "Main_p");
                    d.Main_p = d.Main_p * 10;
                    storeField(d, "Main_i");
                    d.Main_i = d.Main_i + 1;
                    break;
                }
            }
        }

        /**
          *     .
          */
        protected void doStepBackward(int level) {
            //     
            switch (state) {
                case 1: { // 
                    restoreSection();
                    break;
                }
                case 2: { //    
                    restoreSection();
                    break;
                }
                case 3: { //   
                    break;
                }
                case 4: { //    
                    restoreSection();
                    break;
                }
                case 5: { //   
                    break;
                }
                case 6: { //  counter
                    restoreSection();
                    break;
                }
                case 7: { //  j
                    restoreSection();
                    break;
                }
                case 8: { //      
                    restoreSection();
                    break;
                }
                case 9: { //     
                    break;
                }
                case 10: { //  
                    restoreSection();
                    break;
                }
                case 11: { //  j
                    restoreSection();
                    break;
                }
                case 12: { //    
                    restoreSection();
                    break;
                }
                case 13: { //    
                    break;
                }
                case 14: { //  
                    restoreSection();
                    break;
                }
                case 15: { //  
                    restoreSection();
                    break;
                }
                case 16: { //  j
                    restoreSection();
                    break;
                }
                case 17: { //     
                    restoreSection();
                    break;
                }
                case 18: { //  i
                    restoreSection();
                    break;
                }
            }

            //    
            switch (state) {
                case 1: { // 
                    state = START_STATE; 
                    break;
                }
                case 2: { //    
                    state = 1; // 
                    break;
                }
                case 3: { //   
                    if (stack.popBoolean()) {
                        state = 18; //  i
                    } else {
                        state = 2; //    
                    }
                    break;
                }
                case 4: { //    
                    state = 3; //   
                    break;
                }
                case 5: { //   
                    if (stack.popBoolean()) {
                        state = 7; //  j
                    } else {
                        state = 4; //    
                    }
                    break;
                }
                case 6: { //  counter
                    state = 5; //   
                    break;
                }
                case 7: { //  j
                    state = 6; //  counter
                    break;
                }
                case 8: { //      
                    state = 5; //   
                    break;
                }
                case 9: { //     
                    if (stack.popBoolean()) {
                        state = 11; //  j
                    } else {
                        state = 8; //      
                    }
                    break;
                }
                case 10: { //  
                    state = 9; //     
                    break;
                }
                case 11: { //  j
                    state = 10; //  
                    break;
                }
                case 12: { //    
                    state = 9; //     
                    break;
                }
                case 13: { //    
                    if (stack.popBoolean()) {
                        state = 16; //  j
                    } else {
                        state = 12; //    
                    }
                    break;
                }
                case 14: { //  
                    state = 13; //    
                    break;
                }
                case 15: { //  
                    state = 14; //  
                    break;
                }
                case 16: { //  j
                    state = 15; //  
                    break;
                }
                case 17: { //     
                    state = 13; //    
                    break;
                }
                case 18: { //  i
                    state = 17; //     
                    break;
                }
                case END_STATE: { //  
                    state = 3; //   
                    break;
                }
            }
        }

        /**
          *    
          */
        public String getComment() {
            String comment = ""; 
            Object[] args = null; 
            //  
            switch (state) {
                case START_STATE: { //  
                    comment = RadixSort.this.getComment("Main.START_STATE"); 
                    break;
                }
                case 1: { // 
                    comment = RadixSort.this.getComment("Main.Initialization"); 
                    break;
                }
                case 6: { //  counter
                    comment = RadixSort.this.getComment("Main.inccounter"); 
                    args = new Object[]{new Integer(d.Main_i), new Integer(d.Main_j), new Integer(d.Main_digit)}; 
                    break;
                }
                case 10: { //  
                    comment = RadixSort.this.getComment("Main.sumcounter"); 
                    args = new Object[]{new Integer(d.Main_j)}; 
                    break;
                }
                case 14: { //  
                    comment = RadixSort.this.getComment("Main.fillresult"); 
                    args = new Object[]{new Integer(d.Main_i), new Integer(d.Main_j), new Integer(d.Main_digit), new Integer(d.counter[d.Main_digit])}; 
                    break;
                }
                case 15: { //  
                    comment = RadixSort.this.getComment("Main.inccounter2"); 
                    args = new Object[]{new Integer(d.Main_digit)}; 
                    break;
                }
                case END_STATE: { //  
                    comment = RadixSort.this.getComment("Main.END_STATE"); 
                    break;
                }
            }

            return java.text.MessageFormat.format(comment, args); 
        }

        /**
          *     
          */
        public void drawState() {
            switch (state) {
                case START_STATE: { //  
                    d.visualizer.updateArray(-1, -1, -1);
                    break;
                }
                case 1: { // 
                    d.visualizer.updateArray(-1, -1, -1);
                    break;
                }
                case 6: { //  counter
                    d.visualizer.updateArray(d.Main_j, d.Main_digit, -1);
                    break;
                }
                case 10: { //  
                    d.visualizer.updateArray(-1, d.Main_j, -1);
                    break;
                }
                case 14: { //  
                    d.visualizer.updateArray(d.Main_j, d.Main_digit, d.counter[d.Main_digit]);
                    break;
                }
                case 15: { //  
                    d.visualizer.updateArray(-1, d.Main_digit, -1);
                    break;
                }
                case END_STATE: { //  
                    d.visualizer.updateArray(-1, -1, -1);
                    break;
                }
            }
        }
    }
}
